
class CRKData;
class CComponent;

class CCell : public CRKData
{
public:
	CCell();
//protected:
	~CCell();
private:
	int neqs;

	double Cm; // 20.0 pF
	double Dm; // 60.0 micrometer :: diameter of the cell
	double Lm; // 70.0 micrometer :: length of the cell

	double Eleak; //  -65.0 mV
	double ENa;   //   50.0 mV
	double EK;    // -100.0 mV
	double ECa;   //   50.0 mV

	double dGleak; //  0.002 mS/cm^2
	double Gleak;

	double Am;  //  = 3.14 * Dm * Lm;    // (squre_micrometer) surface area
	double InvCm; // = 1/Cm;
	double fac;  // = 10;  // conversion factor (mS/cm^2) -> (pS/micrometer^2)

	CNaChannel*  pNaChannel;
	CKChannel*   pKChannel;
	CTCaChannel* pTCaChannel;

	double dNa;
	double dK;
	double dTCa;

	double Iinj;   // 2000.0 (pA)
	double Ton;    //   20 ms
	double Toff;   //   40 ms

private:
	int addComponent(CComponent* pComp);
public:
	int initCell(double h);
	void rhs(double x, double*y, double* dy);
};

