

class CCell;
class CEnv;

class CComponent
{
public:
	CComponent();
protected:
	~CComponent();

public:
	virtual void initState(double* y){};
	virtual void rhs(double x, double* y, double* dy){};

public:
	int neqs;
	int bp;
	double density;
	double G;         // max conductance
	CCell* pCell;
	CEnv* pEnv;

};


class CNaChannel : public CComponent
{
public:
	CNaChannel();
	~CNaChannel();

private:
	double vtraub;

public:
	void initState(double* y);
	void rhs(double x, double*y, double* dy);
};


class CKChannel : public CComponent
{
public:
	CKChannel();
	~CKChannel();

private:
	double vtraub;

public:
	void initState(double* y);
	void rhs(double x, double*y, double* dy);
};

class CTCaChannel : public CComponent
{
public:
	CTCaChannel();
	~CTCaChannel();

private:

public:
	void initState(double* y);
	void rhs(double x, double*y, double* dy);
};